image: registry.gitlab.com/brd.com/deploy-it/ci-base:0.3
services:
  - docker:dind

stages:
# For now, we're just going to do transpilation in the target app.
  - publish

variables:
  DOCKER_HOST: tcp://docker:2375/
  DOCKER_DRIVER: overlay2


# Use the global script to change things about every script.  Setting
.global: &global
  stage: publish
  image: node:14

publish-lib:
  <<: *global
  rules:
    - if: '$CI_COMMIT_TAG || $CI_COMMIT_BRANCH == "main"'
  script:
    - echo //registry.npmjs.org/:_authToken=$NPM_TOKEN > ~/.npmrc
    - semver
    - sed -i 's|0.0.0-VERSION|'"$VERSION"'|' package.json
    - npm publish --access public

publish-mr:
  <<: *global
  rules:
    - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
  environment:
    name: $CI_COMMIT_REF_SLUG
    url: https://www.npmjs.com/package/@brd.com/butter-vue/v/$VERSION
  script:
    - echo //registry.npmjs.org/:_authToken=$NPM_TOKEN > ~/.npmrc
    - export VERSION=$(git describe --tags --abbrev=1 origin/main | awk -F '-' '{print $1"."$2}' | sed 's|\.$||' | sed 's|\.\.||' )
    - export COMMITS=$(git log --oneline origin/main..HEAD | wc -l | awk '{print $1}')
    - export MERGE_REQUEST_IID=$(git ls-remote --refs origin refs/merge-requests/*/head | grep $(git rev-parse HEAD) | awk -F / '{print$3}')
    - if [ -z $MERGE_REQUEST_IID ] ; then echo "Make sure to create an MR for this branch" ; exit 1 ; fi
    - export NPM_RANGE="^$VERSION-mr${MERGE_REQUEST_IID}"
    - echo $VERSION $MERGE_REQUEST_IID $COMMITS
    - export VERSION=$(coerceSemver $VERSION-mr${MERGE_REQUEST_IID}.$COMMITS)
    - echo $VERSION
    - sed -i 's|0.0.0-VERSION|'"$VERSION"'|' package.json
    - npm publish --access public --tag mr${MERGE_REQUEST_IID}
    - echo "Install this version by running npm i --save @brd.com/butter-vue@mr${MERGE_REQUEST_IID}"


.functions: &functions |
  function coerceSemver() {
    if [[ $1 == *"-"* ]]
    then
      version=${1%%-*}
      rest=${1#*-}
    else
      version=$1
      rest=
    fi

    p1=$(awk -F . '{ print $1 }' <<< $version)
    p2=$(awk -F . '{ print $2 }' <<< $version)
    p3=$(awk -F . '{ print $3 }' <<< $version)

    version=${p1:-0}.${p2:-0}.${p3:-0}

    if [ -z $rest ]
    then
      echo $version
    else
      echo $version-$rest
    fi
  }

  function semver() {
    if [ -z $CI_BUILD_TAG ]
    then
      echo "No build tag :("
      git describe --tags --abbrev=1
      export v=$(git describe --tags --abbrev=1 | awk -F '-' '{print $1"."$2}' | sed 's|\.$||' | sed 's|\.\.||' )
      export VERSION=$(coerceSemver $v)
    else
      echo "WE've got a build tag: " $CI_BUILD_TAG
      export VERSION=$(coerceSemver $CI_BUILD_TAG)
    fi
  }

before_script:
  - source /gitlab-functions || echo 'not a supported image'
  - *functions
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN registry.gitlab.com || echo Failed to login to registry.gitlab.com
  - export BUILDER_IMAGE=$CI_REGISTRY_IMAGE/builder:$(sha1sum docker/Dockerfile-dev package.* | sha1sum | awk '{print $1}')
  - export IMAGE=$CI_REGISTRY_IMAGE:$VERSION
  - export ROOT_IMAGE=$CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  - prep_host_pwd || echo 'prep_host_pwd not supported'
